# Game: Boomball Main

execute as @a store result score @s snowballCount run clear @s minecraft:snowball 0


execute as @e[tag=bombChicken,tag=thrown] at @s[nbt={OnGround:1b}] run kill @e[type=chicken,tag=passenger,limit=1,sort=nearest]
execute as @e[tag=bombChicken,tag=thrown] at @s[nbt={OnGround:1b}] run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:2,CustomName:"\"Extra Explosive Chicken\""}
execute as @e[tag=bombChicken,tag=thrown] at @s[nbt={OnGround:1b}] run kill @s
execute as @e[tag=bombChicken,tag=thrown] at @s unless block ^ ^ ^1 #minecraft:non_solid run kill @e[type=chicken,tag=passenger,limit=1,sort=nearest]
execute as @e[tag=bombChicken,tag=thrown] at @s unless block ^ ^ ^1 #minecraft:non_solid run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:2,CustomName:"\"Extra Explosive Chicken\""}
execute as @e[tag=bombChicken,tag=thrown] at @s unless block ^ ^ ^1 #minecraft:non_solid run kill @s
execute as @e[tag=bombChicken,tag=thrown] at @s anchored feet positioned ^ ^ ^1 if entity @a[dx=0.5,dy=1,dz=0.5] run kill @e[type=chicken,tag=passenger,limit=1,sort=nearest]
execute as @e[tag=bombChicken,tag=thrown] at @s anchored feet positioned ^ ^ ^1 if entity @a[dx=0.5,dy=1,dz=0.5] run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:2,CustomName:"\"Extra Explosive Chicken\""}
execute as @e[tag=bombChicken,tag=thrown] at @s anchored feet positioned ^ ^ ^1 if entity @a[dx=0.5,dy=1,dz=0.5] run kill @s

execute as @e[tag=bomb,tag=thrown] at @s[nbt={OnGround:1b}] run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:1,CustomName:"\"Boomball\""}
execute as @e[tag=bomb,tag=thrown] at @s[nbt={OnGround:1b}] run kill @s
execute as @e[tag=bomb,tag=thrown] at @s unless block ^ ^ ^1 #minecraft:non_solid run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:1,CustomName:"\"Boomball\""}
execute as @e[tag=bomb,tag=thrown] at @s unless block ^ ^ ^1 #minecraft:non_solid run kill @s
execute as @e[tag=bomb,tag=thrown] at @s anchored feet positioned ^ ^ ^1 if entity @a[dx=0.5,dy=1,dz=0.5] run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:1,CustomName:"\"Boomball\""}
execute as @e[tag=bomb,tag=thrown] at @s anchored feet positioned ^ ^ ^1 if entity @a[dx=0.5,dy=1,dz=0.5] run kill @s


scoreboard players add boomball gameData 1
execute if score boomball gameData matches 1..20 as @a if score @s snowballCount matches ..9 run experience set @s 3 levels
execute if score boomball gameData matches 21..40 as @a if score @s snowballCount matches ..9 run experience set @s 2 levels
execute if score boomball gameData matches 41..60 as @a if score @s snowballCount matches ..9 run experience set @s 1 levels
execute as @a if score @s snowballCount matches 10 run experience set @s 0 levels
execute as @a[scores={death=2}] run experience set @s 0 levels
execute if score boomball gameData matches 60 as @a[scores={death=0}] if score @s snowballCount matches ..9 run give @s snowball{display:{Name:"{\"text\":\"Boomball\",\"color\":\"red\",\"italic\":false}"},NoDrop:1b}
execute if score boomball gameData matches 60 run scoreboard players set boomball gameData 0

scoreboard players add boomballChicken gameData 1
execute as @e[type=chicken,tag=!passenger,nbt={OnGround:1b}] run data merge entity @s {CustomName:"{\"text\":\"Extra Explosive Chicken\",\"color\":\"red\"}",CustomNameVisible:1b}
execute if score boomballChicken gameData matches 160 run spreadplayers 138 137 15 25 false @e[type=armor_stand,tag=chickenSpawn,limit=1]
execute if score boomballChicken gameData matches 160 at @e[type=armor_stand,tag=chickenSpawn,limit=1] run summon chicken ~ ~-10 ~ {Invulnerable:1b}
execute if score boomballChicken gameData matches 160 run tag @e[type=chicken,tag=!teleported,tag=!passenger] add teleported
execute if score boomballChicken gameData matches 160 run scoreboard players set boomballChicken gameData 0

execute as @a at @s if entity @e[type=chicken,tag=!passenger,distance=..1] run playsound entity.item.pickup voice @s ~ ~ ~
execute as @a at @s if entity @e[type=chicken,tag=!passenger,distance=..1] run give @s egg{display:{Name:"{\"text\":\"Extra Explosive Chicken\",\"color\":\"red\",\"italic\":false}"},NoDrop:1b}
execute at @a run tp @e[type=chicken,tag=!passenger,distance=..1] ~ ~-200 ~


execute at @e[type=egg] run summon armor_stand ~ ~ ~ {Tags:["bombChicken"],Invisible:1,Marker:1,Small:1,Passengers:[{id:"minecraft:chicken",NoAI:1b,Tags:["passenger"]}]}
execute at @e[type=armor_stand,tag=bombChicken,tag=!thrown] as @a[limit=1,sort=nearest] at @s run tp @e[tag=bombChicken,tag=!thrown] @s
execute as @e[tag=bombChicken,tag=!thrown] at @s run tp @s ~ ~1.22 ~
execute as @e[tag=bombChicken,tag=!thrown] at @s run function game:boomball_throw
kill @e[type=egg]

execute at @e[type=snowball] run summon armor_stand ~ ~ ~ {Tags:["bomb"],ArmorItems:[{},{},{},{id:"minecraft:tnt",Count:1}],Invisible:1,Marker:1,Small:1}
execute at @e[type=armor_stand,tag=bomb,tag=!thrown] as @a[limit=1,sort=nearest] at @s run tp @e[tag=bomb,tag=!thrown] @s
execute as @e[tag=bomb,tag=!thrown] at @s run tp @s ~ ~1.62 ~
execute as @e[tag=bomb,tag=!thrown] at @s run function game:boomball_throw
kill @e[type=snowball]


tag @a[scores={death=0},limit=1] add finish
execute unless entity @a[scores={death=0},tag=!finish] run tag @a[scores={death=0}] add winner
execute unless entity @a[scores={death=0},tag=!finish] run title @a title ["",{"selector":"@a[tag=winner]","color":"dark_green"}]
execute unless entity @a[scores={death=0},tag=!finish] run title @a subtitle [{"text":"won ","color":"gray"},{"score":{"objective":"gameData","name":"pointsRewarded"},"color":"gold"},{"text":" points","color":"gray"}]
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players operation @a[tag=winner] points += pointsRewarded gameData
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players operation @a[tag=winner] totalPoints += pointsRewarded gameData
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players operation totalPoints statistics += pointsRewarded gameData
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players add @a[tag=winner] roundsWon 1
execute unless entity @a[scores={death=0},tag=!finish] run tellraw @a ["",{"text":"- ","color":"gold"},{"selector":"@a[tag=winner]","color":"dark_green"},{"text":" seems to know how to use these boomballs!","color":"gray"}]
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players set inGame gameData 0
tag @a[tag=finish] remove finish

execute at @e[type=chicken,tag=passenger] run playsound entity.chicken.hurt voice @a ~ ~ ~ 1 1