# Game: Border Battle

execute if score borderTimer gameData matches -200 run team modify players friendlyFire true
execute if score borderTimer gameData matches -200 run worldborder set 35 10
execute if score borderTimer gameData matches -200 run effect clear @a resistance
execute if score borderTimer gameData matches 0 run function game:borderbattle_direction
execute if score borderTimer gameData matches 0 run worldborder set 9 120
execute if score borderTimer gameData matches 0..2400 as @e[type=armor_stand,tag=borderLocation] at @s run tp @s ^ ^ ^0.13
execute if score borderTimer gameData matches 0..2400 at @e[type=armor_stand,tag=borderLocation] if entity @e[type=armor_stand,tag=borderDestination,distance=..1] run function game:borderbattle_direction
execute if score borderTimer gameData matches 0..2400 at @e[type=armor_stand,tag=borderLocation] run worldborder center ~ ~
execute if score borderTimer gameData matches 2401 run worldborder set 1 5
execute if score borderTimer gameData matches -200..2401 run scoreboard players add borderTimer gameData 1

tag @a[scores={death=0},limit=1] add finish
execute unless entity @a[scores={death=0},tag=!finish] run tag @a[scores={death=0}] add winner
execute unless entity @a[scores={death=0},tag=!finish] run title @a title ["",{"selector":"@a[tag=winner]","color":"dark_green"}]
execute unless entity @a[scores={death=0},tag=!finish] run title @a subtitle [{"text":"won ","color":"gray"},{"score":{"objective":"gameData","name":"pointsRewarded"},"color":"gold"},{"text":" points","color":"gray"}]
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players operation @a[tag=winner] points += pointsRewarded gameData
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players operation @a[tag=winner] totalPoints += pointsRewarded gameData
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players operation totalPoints statistics += pointsRewarded gameData
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players add @a[tag=winner] roundsWon 1
execute unless entity @a[scores={death=0},tag=!finish] run tellraw @a ["",{"text":"- ","color":"gold"},{"selector":"@a[tag=winner,limit=1,sort=random]","color":"dark_green"},{"text":" knows the limits!","color":"gray"}]
execute unless entity @a[scores={death=0},tag=!finish] run scoreboard players set inGame gameData 0
tag @a remove finish